<?php
require_once('include/SugarFields/Fields/Base/SugarFieldBase.php');

class SugarFieldEnumaddition extends SugarFieldBase {
	function getDetailViewSmarty($parentFieldArray, $vardef, $displayParams, $tabindex)
	{
		return parent::getDetailViewSmarty($parentFieldArray, $vardef, $displayParams, $tabindex);
	}
	
	function getEditViewSmarty($parentFieldArray, $vardef, $displayParams, $tabindex)
	{
		return $this->getSmartyView($parentFieldArray, $vardef, $displayParams, $tabindex, 'EditView');
	}
	
	public function save(&$bean, $params, $field, $properties, $prefix = '') {
		global $db;
		if ( !isset($params[$prefix.$field]) ) {
            return;
        }
		$bean->$field = implode(",",$params[$prefix.$field]);
	}

	function getSearchViewSmarty($parentFieldArray, $vardef, $displayParams, $tabindex) {
		
		if(empty($displayParams['size'])) {
		   $displayParams['size'] = 6;
		}
		
		$this->setup($parentFieldArray, $vardef, $displayParams, $tabindex);
		return $this->fetch($this->findTemplate('SearchView'));
    }
	
	function setup($parentFieldArray, $vardef, $displayParams, $tabindex, $twopass=true) {
        if ( !isset($vardef['options_list']) && isset($vardef['options']) && !is_array($vardef['options'])) {
            $vardef['options_list'] = $GLOBALS['app_list_strings'][$vardef['options']];
        }
        return parent::setup($parentFieldArray, $vardef, $displayParams, $tabindex, $twopass);
    }
	
	function getSearchWhereValue($fieldValue,$bean,$fieldName,$customField) { 
		global $db;
		$newFieldValue = "";
		$tableName = $bean->table_name;
		if($customField)
			$tableName = $tableName."_cstm";
		$counter = 0;
		$dbField = $tableName.".".$fieldName;
		foreach($fieldValue as $key => $value)
		{
			if(!empty($value))
			{
				$quoteValue = $db->quote($value);
				$newFieldValue .= $dbField." LIKE '%".$quoteValue."%'";
			}
			if(($counter+1) < count($fieldValue) && count($fieldValue) > 1)
				$newFieldValue .= " OR ";
			$counter++;
		}
		return $newFieldValue;
	}
	public function importSanitize()
	{
		
	}
	
	public function formatField($rawField, $vardef){
		global $app_list_strings;
		
		if(!empty($vardef['options'])){
			$option_array_name = $vardef['options'];
			
			if(!empty($app_list_strings[$option_array_name][$rawField])){
				return $app_list_strings[$option_array_name][$rawField];
			}else {
				return $rawField;
			}
		} else {
			return $rawField;
		}
    }
}